﻿using System;
using System.Collections.Generic;
using System.Drawing.Text;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

using ProjectBoat_bae.DrawningObjects;
using ProjectBoat_bae.Entities;

namespace ProjectBoat_bae
{
    internal static class ExtentionBoat
    {
        // Разделитель для записи информации по объекту в файл
        private static readonly char _separatorForObject = ':';

        // Создание объекта из строки
        public static Drawningboat? CreateDrawningBoat(this string info, char _separatorForObject, int _pictureWidth, int _pictureHeight)
        {
            string[] strs = info.Split(_separatorForObject);
            if (strs.Length == 3)
            {
                return new Drawningboat(Convert.ToInt32(strs[0]),
                Convert.ToInt32(strs[1]), Color.FromName(strs[2]), _pictureWidth, _pictureHeight);
            }
            if (strs.Length == 7)
            {
                return new DrawningMotorBoat(Convert.ToInt32(strs[0]),
                Convert.ToInt32(strs[1]), Color.FromName(strs[2]),
                Color.FromName(strs[3]), Convert.ToBoolean(strs[4]),
               Convert.ToBoolean(strs[5]), _pictureWidth, _pictureHeight);
            }
            return null;
        }

        // Получение данных для сохранения в файл
        public static string GetDataForSave(this Drawningboat drawningBoat, char _separatorForObject)
        {
            var boat = drawningBoat.EntityBoat;
            var str =
           $"{boat.Speed}{_separatorForObject}{boat.Weight}{_separatorForObject}{boat.BodyColor.Name}";
            if (boat is not EntityMotorBoat motorBoat)
            {
                return str;
            }
            return
           $"{str}{_separatorForObject}{motorBoat.AdditionalColor.Name}{_separatorForObject}{motorBoat.Body}{_separatorForObject}{motorBoat.Wing}{_separatorForObject}";
        }

    }
}

