﻿//using NLog;
using Microsoft.Extensions.Configuration;
using Microsoft.Extensions.DependencyInjection;
using Microsoft.Extensions.Logging;
using Microsoft.VisualBasic.ApplicationServices;
using NLog.Extensions.Logging;
using Serilog;


namespace ProjectBoat_bae
{
    internal static class Program
    {
        /// <summary>
        ///  The main entry point for the application.
        /// </summary>
        [STAThread]
        static void Main()
        {
            // To customize application configuration such as set high DPI settings or default font,
            // see https://aka.ms/applicationconfiguration.
            ApplicationConfiguration.Initialize();
            var services = new ServiceCollection();
            ConfigureServices(services);
            using (ServiceProvider serviceProvider = services.BuildServiceProvider())
            {
                Application.Run((serviceProvider.GetRequiredService<FormBoatCollection>()));
            }
        }

        private static void ConfigureServices(ServiceCollection services)
        {
            services.AddSingleton<FormBoatCollection>().AddLogging(option =>
            {
                string[] path = Directory.GetCurrentDirectory().Split('\\');
                string pathNeed = "";
                for (int i = 0; i < path.Length - 3; i++)
                {
                    pathNeed += path[i] + "\\";
                }
                //используется для создания исходных текстов конфигурации для приложени
                //SetBasePath Задает базовый путь для файла конфигурации к текущему каталогу приложения.
                // файл JSON в качестве источника конфигурации. 
                var configuration = new ConfigurationBuilder().SetBasePath(Directory.GetCurrentDirectory()).AddJsonFile(path: $"{pathNeed}appsettings.json", optional: false, reloadOnChange: true).Build();
                //настроить формат записи логов
                //используется для настройки регистратора Serilog.
                var logger = new LoggerConfiguration().ReadFrom.Configuration(configuration).CreateLogger();
                option.SetMinimumLevel(LogLevel.Information);
                option.AddSerilog(logger);
            });
        }
    }
}